import { dynamicAtlasManager, macro, _decorator, Component, Node, Label, instantiate, v3 } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('DrawScript')
export class DrawScript extends Component {
    @property(Node)
    public spNode: Node = null;
    @property(Label)
    public label: Label = null;

    private _count: number = 0;

    start() {

        //开启动态合图--耗内存--关闭动态合图
        dynamicAtlasManager.enabled = false;
        macro.ENABLE_TRANSPARENT_CANVAS = false;

        this.schedule(this.createSp, 2)
        this.schedule(this.sortZindex, 1)
    }

    private createSp() {
        let count = 100;
        this._count += count;
        this.label.string = this._count+'';
        for (let i = 0; i < count; i++) {
            let spNode = instantiate(this.spNode);
            spNode.parent = this.node;
            spNode.setPosition(v3(Math.random() * 900 - 450, Math.random() * 500 - 250));
        }
      

        if (this._count > 100) {
            this.unschedule(this.createSp);
        }
    }

    private sortZindex(){
        this.node.children.sort(function (a, b) {
            return b.position.y - a.position.y
        })
    }

}

